/*
 * Copyright (c) 2019-2020, Billy Laws <blaws05@gmail.com>
 * Copyright (c) 2019-2022, CTCaer <ctcaer@gmail.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; version 2 of the License.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
 * more details.
 *
 */

#include "../nx-panels/panel-o-720p-6-2.dtsi"
#include "../nx-panels/panel-j-720p-6-2.dtsi"
#include "../nx-panels/panel-a-720p-6-2.dtsi"
#include "../nx-panels/panel-i-720p-6-2.dtsi"
#include "../nx-panels/panel-a-720p-5-5.dtsi"
#include "../nx-panels/panel-i-720p-5-5.dtsi"
#include "../nx-panels/panel-s-720p-5-5.dtsi"
#include "../nx-panels/panel-s-720p-7-0.dtsi"

/ {
	backlight {
		compatible = "pwm-backlight";
		status = "okay";
		label = "backlight";
		power-supply = <&max77620_sd3>;

		panel-o-720p-6-0-bl {
			compatible = "o,720-1280-6-0-bl";
			status = "okay";
			pwms = <&tegra_pwm 0 33898>;
			max-brightness = <255>;
			default-brightness = <150>;
		};
	};

	host1x {
		/* tegradc.0: DSI */
		dc@54200000 {
			status = "okay";
			nvidia,dc-flags = <TEGRA_DC_FLAG_ENABLED>;
			nvidia,emc-clk-rate = <204000000>;
			nvidia,fb-bpp = <32>; /* bits per pixel */
			nvidia,fb-flags = <TEGRA_FB_FLIP_ON_PROBE>;
			nvidia,fbmem-size = <0x400000>; /* 4MB: No-panning 720x1280 */
			nvidia,dc-or-node = "/host1x/dsi";
			nvidia,dc-connector = <&dsi>;
			win-mask = <0x7>; /* Limit to Window A/B/C. (Window D disabled) */
		};

		/* tegradc.1: DP */
		dc@54240000 {
			status = "okay";
			nvidia,dc-flags = <TEGRA_DC_FLAG_ENABLED>;
			nvidia,emc-clk-rate = <300000000>;
			nvidia,fb-bpp = <32>; /* bits per pixel */
			nvidia,fb-flags = <TEGRA_FB_FLIP_ON_PROBE>;
			nvidia,dc-or-node = "/host1x/sor1";
			nvidia,dc-connector = <&sor1>;
			win-mask = <0x7>; /* Use all supported windows (Window A/B/C) */
			extcon-cables = <&bm92t 3>;
			extcon-cable-names = "typec1";
			#extcon-cells = <1>;
		};

		dsi {
			nvidia,dsi-controller-vs = <DSI_VS_1>;
			status = "okay";
			nvidia,active-panel = <&panel_o_720p_6_2>;

			panel-o-720p-6-0 {
				compatible = "o,720-1280-6-0";
				/* nvidia,panel-bl-en-gpio = <&gpio TEGRA_GPIO(V, 1) 0>; */ /* PV1. - Handled by vdd_lcd_bl_en-supply */
				nvidia,panel-bl-pwm-gpio = <&gpio TEGRA_GPIO(V, 0) 0>; /* PV0 */
				nvidia,panel-rst-gpio = <&gpio TEGRA_GPIO(V, 2) 0>; /* PV2 */
			};

			panel-j-720p-6-2 {
				nvidia,dsi-dpd-pads = <DSIC_DPD_EN DSID_DPD_EN>;
			};
			panel-a-720p-6-2 {
				nvidia,dsi-dpd-pads = <DSIC_DPD_EN DSID_DPD_EN>;
			};
			panel-i-720p-6-2 {
				nvidia,dsi-dpd-pads = <DSIC_DPD_EN DSID_DPD_EN>;
			};
			panel-o-720p-6-2 {
				nvidia,dsi-dpd-pads = <DSIC_DPD_EN DSID_DPD_EN>;
			};

			panel-a-720p-5-5 {
				nvidia,dsi-dpd-pads = <DSIC_DPD_EN DSID_DPD_EN>;
			};
			panel-i-720p-5-5 {
				nvidia,dsi-dpd-pads = <DSIC_DPD_EN DSID_DPD_EN>;
			};
			panel-s-720p-5-5 {
				nvidia,dsi-dpd-pads = <DSIC_DPD_EN DSID_DPD_EN>;
			};

			panel-s-720p-7-0 {
				nvidia,dsi-dpd-pads = <DSIC_DPD_EN DSID_DPD_EN>;
				nvidia,panel-rst-gpio = <&gpio TEGRA_GPIO(V, 2) 0>; /* PV2 */
				nvidia,panel-irq-gpio = <&gpio TEGRA_GPIO(H, 0) 0>; /* WIFI_EN_PH0 */
				disp-default-out {
					nvidia,out-rotation = <270>;
				};
			};
		};

		sor {
			status = "disabled";
		};

		dpaux {
			status = "disabled";
		};

		vi {
			status = "disabled";
		};

		tsec {
			assigned-clocks = <&tegra_car TEGRA210_CLK_TSEC>;
			assigned-clock-parents =
				<&tegra_car TEGRA210_CLK_PLL_P>;
			assigned-clock-rates = <408000000>;
		};

		sor1 {
			status = "okay";
			nvidia,active-panel = <&sor1_dp_display>;
			nvidia,typec-port = /bits/ 8 <1>;
			dp-display {
				status = "okay";
				compatible = "dp, display";
				nvidia,hpd-gpio = <&gpio TEGRA_GPIO(CC, 1) 1>; /* PN7 */
				nvidia,is_ext_dp_panel = <1>;
				nvidia,lanes = <2>;
				nvidia,fast-lt-disable;

				disp-default-out {
					/* nvidia,out-max-pixclk = <3333>; */ /* Odin: KHZ2PICOS(300000) */
					nvidia,out-type = <TEGRA_DC_OUT_DP>;
					nvidia,out-align = <TEGRA_DC_ALIGN_MSB>;
					nvidia,out-order = <TEGRA_DC_ORDER_RED_BLUE>;
					nvidia,out-flags = <TEGRA_DC_OUT_CONTINUOUS_MODE>;
					nvidia,out-hdcp-policy = <TEGRA_DC_HDCP_POLICY_ALWAYS_OFF>; /* Can be enabled via hdcp ioctl */
					nvidia,out-pins = <TEGRA_DC_OUT_PIN_H_SYNC TEGRA_DC_OUT_PIN_POL_LOW
							   TEGRA_DC_OUT_PIN_V_SYNC TEGRA_DC_OUT_PIN_POL_LOW
							   TEGRA_DC_OUT_PIN_PIXEL_CLOCK TEGRA_DC_OUT_PIN_POL_LOW
							   TEGRA_DC_OUT_PIN_DATA_ENABLE TEGRA_DC_OUT_PIN_POL_HIGH>;
					nvidia,out-parent-clk = "pll_d2_out0";
				};

				/* Default T210 lt-data */
				lt-data {
					tegra-dp-vs-regs {
						pc2_l0 = < 0x13 0x19 0x1e 0x28 0x1e 0x25 0x2d 0x28 0x32 0x3c >;
						pc2_l1 = < 0x12 0x17 0x1b 0x25 0x1c 0x23 0x2a 0x25 0x2f 0x39 >;
						pc2_l2 = < 0x12 0x16 0x1a 0x22 0x1b 0x20 0x27 0x24 0x2d 0x36 >;
						pc2_l3 = < 0x11 0x14 0x17 0x1f 0x19 0x1e 0x24 0x22 0x2a 0x32 >;
					};
					tegra-dp-pe-regs {
						pc2_l0 = < 0x00 0x08 0x12 0x24 0x01 0x0e 0x1d 0x01 0x13 0x00 >;
						pc2_l1 = < 0x00 0x08 0x12 0x24 0x00 0x0e 0x1d 0x00 0x13 0x00 >;
						pc2_l2 = < 0x00 0x08 0x12 0x24 0x00 0x0e 0x1d 0x00 0x13 0x00 >;
						pc2_l3 = < 0x00 0x08 0x12 0x24 0x00 0x0e 0x1d 0x00 0x13 0x00 >;
					};
					tegra-dp-pc-regs {
						pc2_l0 = < 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 >;
						pc2_l1 = < 0x02 0x02 0x04 0x05 0x02 0x04 0x05 0x04 0x05 0x05 >;
						pc2_l2 = < 0x04 0x05 0x08 0x0b 0x05 0x09 0x0b 0x08 0x0a 0x0b >;
						pc2_l3 = < 0x05 0x09 0x0b 0x12 0x09 0x0d 0x12 0x0b 0x0f 0x12 >;
					};
					tegra-dp-tx-pu {
						pc2_l0 = < 0x20 0x30 0x40 0x60 0x30 0x40 0x60 0x40 0x60 0x60 >;
						pc2_l1 = < 0x20 0x20 0x30 0x50 0x30 0x40 0x50 0x40 0x50 0x60 >;
						pc2_l2 = < 0x20 0x20 0x30 0x40 0x30 0x30 0x40 0x40 0x50 0x60 >;
						pc2_l3 = < 0x20 0x20 0x20 0x40 0x30 0x30 0x40 0x40 0x40	0x60 >;
					};
				};

				dp-lt-settings {
					lt-setting@0 {
						nvidia,drive-current = <DRIVE_CURRENT_L0 DRIVE_CURRENT_L0 DRIVE_CURRENT_L0 DRIVE_CURRENT_L0>;
						nvidia,lane-preemphasis = <PRE_EMPHASIS_L0 PRE_EMPHASIS_L0 PRE_EMPHASIS_L0 PRE_EMPHASIS_L0>;
						nvidia,post-cursor = <POST_CURSOR2_L0 POST_CURSOR2_L0 POST_CURSOR2_L0 POST_CURSOR2_L0>;
						nvidia,tx-pu = <0>;
						nvidia,load-adj = <0x3>;
					};
					lt-setting@1 {
						nvidia,drive-current = <DRIVE_CURRENT_L0 DRIVE_CURRENT_L0 DRIVE_CURRENT_L0 DRIVE_CURRENT_L0>;
						nvidia,lane-preemphasis = <PRE_EMPHASIS_L0 PRE_EMPHASIS_L0 PRE_EMPHASIS_L0 PRE_EMPHASIS_L0>;
						nvidia,post-cursor = <POST_CURSOR2_L0 POST_CURSOR2_L0 POST_CURSOR2_L0 POST_CURSOR2_L0>;
						nvidia,tx-pu = <0>;
						nvidia,load-adj = <0x4>;
					};
					lt-setting@2 {
						nvidia,drive-current = <DRIVE_CURRENT_L0 DRIVE_CURRENT_L0 DRIVE_CURRENT_L0 DRIVE_CURRENT_L0>;
						nvidia,lane-preemphasis = <PRE_EMPHASIS_L1 PRE_EMPHASIS_L1 PRE_EMPHASIS_L1 PRE_EMPHASIS_L1>;
						nvidia,post-cursor = <POST_CURSOR2_L0 POST_CURSOR2_L0 POST_CURSOR2_L0 POST_CURSOR2_L0>;
						nvidia,tx-pu = <0>;
						nvidia,load-adj = <0x6>;
					};
				};
			};

			hdmi-display {
				status = "disabled";
			};
		};

		dpaux1 {
			status = "okay";
		};

		i2c@546c0000 {
			status = "disabled";
		};
	};
};
